var Memory, MemorySync;
var __slice = Array.prototype.slice;
MemorySync = require('./MemorySync');
Memory = module.exports = function() {
  this._data = {};
  this.ver = 0;
};
Memory.prototype = {
  flush: function(callback) {
    this._data = {};
    this.ver = 0;
    return callback(null);
  },
  _get: MemorySync.prototype.get,
  get: function(path, callback) {
    var value;
    value = this._get(path);
    return callback(null, value, this.ver);
  },
  _set: MemorySync.prototype.set,
  set: function(path, value, ver, callback) {
    try {
      this._set(path, value, ver);
    } catch (err) {
      return callback(err);
    }
    return callback(null, value);
  },
  _del: MemorySync.prototype.del,
  del: function(path, ver, callback) {
    try {
      this._del(path, ver);
    } catch (err) {
      return callback(err);
    }
    return callback(null);
  },
  _push: MemorySync.prototype.push,
  push: function() {
    var callback, path, values, ver, _i;
    path = arguments[0], values = 4 <= arguments.length ? __slice.call(arguments, 1, _i = arguments.length - 2) : (_i = 1, []), ver = arguments[_i++], callback = arguments[_i++];
    try {
      this._push.apply(this, [path].concat(__slice.call(values), [ver]));
    } catch (err) {
      return callback(err);
    }
    return callback.apply(null, [null].concat(__slice.call(values)));
  },
  _pop: MemorySync.prototype.pop,
  pop: function(path, ver, callback) {
    try {
      this._pop(path, ver);
    } catch (err) {
      return callback(err);
    }
    return callback(null);
  },
  _insertAfter: MemorySync.prototype.insertAfter,
  insertAfter: function(path, afterIndex, value, ver, callback) {
    try {
      this._insertAfter(path, afterIndex, value, ver);
    } catch (err) {
      return callback(err);
    }
    return callback(null, afterIndex, value);
  },
  _insertBefore: MemorySync.prototype.insertBefore,
  insertBefore: function(path, beforeIndex, value, ver, callback) {
    try {
      this._insertBefore(path, beforeIndex, value, ver);
    } catch (err) {
      return callback(err);
    }
    return callback(null, beforeIndex, value);
  },
  _remove: MemorySync.prototype.remove,
  remove: function(path, startIndex, howMany, ver, callback) {
    try {
      this._remove(path, startIndex, howMany, ver);
    } catch (err) {
      return callback(err);
    }
    return callback(null, startIndex, howMany);
  },
  _splice: MemorySync.prototype.splice,
  splice: function() {
    var callback, newMembers, path, removeCount, startIndex, ver, _i;
    path = arguments[0], startIndex = arguments[1], removeCount = arguments[2], newMembers = 6 <= arguments.length ? __slice.call(arguments, 3, _i = arguments.length - 2) : (_i = 3, []), ver = arguments[_i++], callback = arguments[_i++];
    try {
      this._splice.apply(this, [path, startIndex, removeCount].concat(__slice.call(newMembers)));
    } catch (err) {
      return callback(err);
    }
    return callback.apply(null, [null, startIndex, removeCount].concat(__slice.call(newMembers)));
  },
  _move: function(path, from, to, ver, options) {
    var value;
    if (options == null) {
      options = {};
    }
    value = this.lookup("" + path + "." + from, false, options).obj;
    if (to < 0) {
      to += this.lookup(path, false, options).obj.length;
    }
    if (from > to) {
      this._insertBefore(path, to, value, ver, options);
      from++;
    } else {
      this._insertAfter(path, to, value, ver, options);
    }
    return this._remove(path, from, 1, ver, options);
  },
  move: function(path, from, to, ver, callback) {
    try {
      this._move(path, from, to, ver);
    } catch (err) {
      return callback(err);
    }
    return callback(null, from, to);
  },
  lookup: MemorySync.prototype.lookup
};