module.exports = {
  isPrivate: function(name) {
    return /(^_)|(\._)/.test(name);
  },
  regExp: function(pattern) {
    if (pattern instanceof RegExp) {
      return pattern;
    } else {
      return new RegExp('^' + pattern.replace(/\.|\*{1,2}/g, function(match, index) {
        if (match === '.') {
          return '\\.';
        }
        if (match === '*') {
          return '([^\\.]+)';
        }
        if (match === '**') {
          if (pattern.length - index === 2) {
            return '(.+)';
          } else {
            return '(.+?)';
          }
        }
      }) + '$');
    }
  },
  fastLookup: function(path, obj) {
    var prop, _i, _len, _ref;
    _ref = path.split('.');
    for (_i = 0, _len = _ref.length; _i < _len; _i++) {
      prop = _ref[_i];
      if (!(obj = obj[prop])) {
        return;
      }
    }
    return obj;
  }
};