var DEFAULT_TRANSPORTS, Model, Racer, Store, browserify, ioClient, socketio, uglify;
Model = require('./Model.server');
Store = require('./Store');
socketio = require('socket.io');
ioClient = require('socket.io-client');
browserify = require('browserify');
uglify = require('uglify-js');
DEFAULT_TRANSPORTS = ['websocket', 'xhr-polling'];
Racer = function(options) {
  var store, storeOptions;
  storeOptions = {};
  storeOptions = {
    redis: options.redis ? options.redis : void 0
  };
  this.store = store = new Store(options.storeAdapter, storeOptions);
  if (options.sockets) {
    this.setSockets(options.sockets, options.socketUri);
  } else if (options.listen) {
    this.listen(options.listen);
  }
};
Racer.prototype = {
  use: function() {
    throw 'Unimplemented';
  },
  setSockets: function(sockets, ioUri) {
    this.sockets = sockets;
    this.store._setSockets(this.sockets);
    return this.store._ioUri = ioUri;
  },
  listen: function(to) {
    var io, socketUri;
    io = socketio.listen(to);
    io.configure(function() {
      io.set('browser client', false);
      return io.set('transports', DEFAULT_TRANSPORTS);
    });
    socketUri = typeof to === 'number' ? ':' + to : '';
    return this.setSockets(io.sockets, socketUri);
  },
  js: function(options, callback) {
    var minify, require, _ref;
    if (typeof options === 'function') {
      _ref = [options, {}], callback = _ref[0], options = _ref[1];
    }
    require = ['racer'];
    options.require = options.require ? require.concat(options.require) : require;
    if ((minify = options.minify) === void 0) {
      minify = true;
    }
    if (minify) {
      options.filter = uglify;
    }
    return ioClient.builder(DEFAULT_TRANSPORTS, {
      minify: minify
    }, function(err, value) {
      if (err) {
        throw err;
      }
      return callback(value + ';' + browserify.bundle(options));
    });
  },
  middleware: function() {
    var store;
    store = this.store;
    return function(req, res, next) {
      var clientId, finish;
      if (!req.session) {
        throw 'Missing session middleware';
      }
      finish = function(clientId) {
        req.model = new Model(clientId);
        return next();
      };
      if (clientId = req.params.clientId || req.body.clientId) {
        return finish(clientId);
      } else {
        return store._nextClientId(finish);
      }
    };
  }
};
exports.Racer = Racer;