var pathParser, transaction;
transaction = require('./transaction');
pathParser = require('./pathParser.server');
transaction.conflict = function(txnA, txnB) {
  var clientIdA, clientIdB, clientVerA, clientVerB, txnAId, _ref, _ref2;
  if (!this.pathConflict(transaction.path(txnA), transaction.path(txnB))) {
    return false;
  }
  txnAId = transaction.id(txnA);
  if (txnAId.charAt(0) !== '#') {
    _ref = transaction.clientIdAndVer(txnA), clientIdA = _ref[0], clientVerA = _ref[1];
    _ref2 = transaction.clientIdAndVer(txnB), clientIdB = _ref2[0], clientVerB = _ref2[1];
    if (clientIdA === clientIdB) {
      if (clientVerA > clientVerB) {
        return false;
      }
    }
  }
  if (txnAId === transaction.id(txnB)) {
    return 'duplicate';
  }
  return 'conflict';
};
transaction.pathConflict = function(pathA, pathB) {
  var pathALen, pathBLen;
  if (pathA === pathB) {
    return true;
  }
  pathALen = pathA.length;
  pathBLen = pathB.length;
  if (pathALen === pathBLen) {
    return false;
  }
  if (pathALen > pathBLen) {
    return pathA.charAt(pathBLen) === '.' && pathA.substring(0, pathBLen) === pathB;
  }
  return pathB.charAt(pathALen) === '.' && pathB.substring(0, pathALen) === pathA;
};
transaction.journalConflict = function(txn, txns) {
  var conflict, i;
  i = txns.length;
  while (i--) {
    if (conflict = this.conflict(txn, JSON.parse(txns[i]))) {
      return conflict;
    }
  }
  return false;
};
transaction.subscribed = function(txn, subs) {
  var path;
  path = transaction.path(txn);
  return pathParser.matchesAnyPattern(path, subs);
};
module.exports = transaction;